#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <algorithm>

using namespace std;

double f(int n1, int n2) {
	if (n2 > n1) {
		return f(n2, n1);
	}

	if (n2 == 0) {
		return double(n1);
	}

	return f(n2, n1 % n2);
}


int main() {
	double a, b;
	cin >> a >> b;
	vector <char>ans{ 'R' };
	double cur_a = 1;
	double cur_b = 1;
	double left_a = 0;
	double left_b = 1;
	double right_a = 1;
	double right_b = 0;
	while (cur_a / cur_b != a / b) {
		if (a / b > cur_a / cur_b) {
			ans.push_back('R');
			left_a = cur_a;
			cur_a = cur_a + right_a;
			left_b = cur_b;
			cur_b = cur_b + right_b;
		}

		else {
			ans.push_back('L');
			right_a = cur_a;
			cur_a = cur_a + left_a;
			right_b = cur_b;
			cur_b = cur_b + left_b;
		}
		float div = f(cur_a, cur_b);
		cur_a /= div;
		cur_b /= div;
	}

	for (int i = 0; i < ans.size(); i++) {
		cout << ans[i];
	}
}