#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <algorithm>

using namespace std;

int main() {
	int n, m, k;
	cin >> n >> m >> k;
	vector <bool> ans;
	vector <vector<int>> roads;
	for (int i = 0; i < n+1; i++) {
		vector<int>a{ 0 };
		roads.push_back(a);
		ans.push_back(false);
	}

	for (int i = 0; i < m; i++) {
		int n1, n2;
		cin >> n1 >> n2;
		roads[n1].push_back(n2);
		roads[n2].push_back(n1);
	}

	vector<pair<int, int>> def;
	for (int i = 0; i < k; i++) {
		int num, h;
		cin >> num >> h;
		pair<int, int> a{ num, h };
		def.push_back(a);
		ans[num] = true;
	}

	for (int i = 0; i < k; i++) {
		int cur_h = def[i].second;
		vector<int> cur_tower{ def[i].first };
		while (cur_h > 0 and cur_tower.size() > 0) {
			vector<int>a;
			for (int j = 0; j < cur_tower.size(); j++) {
				for (int g = 1; g < roads[cur_tower[j]].size(); g++) {
					a.push_back(roads[cur_tower[j]][g]);
					ans[roads[cur_tower[j]][g]] = true;
				}
			}
			cur_h--;
			cur_tower = a;
		}
	}

	int kk = 0;
	for (int i = 0; i < ans.size(); i++) {
		if (ans[i]) {
			kk++;
		}
	}

	cout << kk << endl;
	for (int i = 0; i < ans.size(); i++) {
		if (ans[i]) {
			cout << i << " ";
		}
	}
}